<template>
  <article class="view view--forum-posts">
    <PostList
      :route="postsRoute"
      :username="username"
      :offset="offset"
      :limit="limit"
      :postId="postId"
      view="list-summary"
      :pagination="true"
      sort="-created"
    />
  </article>
</template>

<script>
import { computed, onMounted, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { Constants, ValidationHelper } from '../../../core'
import PostList from '../../components/post-list.vue'

export default {
  name: 'ForumPostsView',
  components: {
    PostList,
  },
  setup() {
    const store = useStore()
    const route = useRoute()

    const username = computed(() => {
      return ValidationHelper.getString(route.query.username, '')
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, 0)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    const postId = computed(() => {
      return ValidationHelper.getInteger(route.query.postId, 0)
    })

    const postsRoute = computed(() => {
      return { name: 'forum-posts', query: { username: store.state.identity.session.username } }
    })

    const title = computed(() => {
      const usernameText = store.state.identity.session.username ? `${store.state.identity.session.username}'s ` : ''
      return `${usernameText}Posts`
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Forum',
          route: { name: 'forum-forum' },
        },
        {
          text: title.value,
          route: null, // No link to self
        },
      ]
    })

    onMounted(() => {
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
    })

    watch(title, (val) => {
      store.dispatch('core/setTitle', val)
    })

    watch(breadcrumbs, (val) => {
      store.dispatch('core/setBreadcrumbs', val)
    })

    return {
      username,
      offset,
      limit,
      postId,
      postsRoute,
    }
  },
}
</script>
